﻿@page "/program-list"
@inject HttpClient HttpClient

<PageTitle Title="プログラム一覧" />

<MudTable Items="programs" Loading="_isLoading" Hover="true" Striped="true" Dense="true" FixedHeader="true" Height="550px"
          Filter="new Func<ProgramEntity,bool>(FilterFunc1)" Class="mt-2">
    <ToolBarContent>
        <MudTextField @bind-Value="_searchString" Placeholder="検索したい文字列を入力しエンター" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
        <MudSpacer />
        <MudTooltip Text="新規追加">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Create)}")" />
        </MudTooltip>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>
            <MudTableSortLabel InitialDirection="SortDirection.Ascending" SortBy="new Func<ProgramEntity, object>(x =>x.SubSystemCompartment.CompartmentWithSystem)">
                @programForLabel.SubSystemCompartment.GetDisplayName(s => s.CompartmentWithSystem)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<ProgramEntity, object>(x =>x.SubSystemCompartment.CompartmentNameWithSystem)">
                @programForLabel.SubSystemCompartment.GetDisplayName(s => s.CompartmentNameWithSystem)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<ProgramEntity, object>(x =>x.ProgramId)">
                @programForLabel.GetDisplayName(p => p.ProgramId)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>
            <MudTableSortLabel SortBy="new Func<ProgramEntity, object>(x =>x.ProgramName)">
                @programForLabel.GetDisplayName(p => p.ProgramName)
            </MudTableSortLabel>
        </MudTh>
        <MudTh>@programForLabel.GetDisplayName(p => p.Purpose)</MudTh>
        <MudTh>@programForLabel.GetDisplayName(p => p.FunctionalOverview)</MudTh>
        <MudTh>操作</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd>@context.SubSystemCompartment.CompartmentWithSystem</MudTd>
        <MudTd>@context.SubSystemCompartment.CompartmentNameWithSystem</MudTd>
        <MudTd>@context.ProgramId</MudTd>
        <MudTd>@context.ProgramName</MudTd>
        <MudTd>@context.Purpose</MudTd>
        <MudTd>@context.FunctionalOverview</MudTd>
        <MudTd>
            <MudTooltip Text="照会">
                <MudFab Icon="@Icons.Material.Filled.ListAlt" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Show)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="編集">
                <MudFab Icon="@Icons.Material.Filled.Edit" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Edit)}/{context.Id}")"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Icon="@Icons.Material.Filled.Delete" Size="Size.Small" Link="@($"/program-detail/{nameof(PageMode.Delete)}/{context.Id}")"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
    <PagerContent>
        <MudTablePager RowsPerPageString="1ページ当りの表示件数" InfoFormat="{all_items}件中 {first_item}～{last_item} 件表示" />
    </PagerContent>
</MudTable>

@code {
    private string _searchString = "";
    private bool _isLoading = false;
    private IEnumerable<ProgramEntity> programs = new List<ProgramEntity>();
    private ProgramEntity programForLabel = new()
    {
        SubSystemCompartment = new()
        {
            SystemCompartment = new()
        }
    };

    protected async override Task OnInitializedAsync()
    {
        _isLoading = true;
        programs = await HttpClient.GetFromJsonAsync<List<ProgramEntity>>("api/Programs");
        _isLoading = false;
    }

    private bool FilterFunc1(ProgramEntity program) => FilterFunc(program, _searchString);

    private bool FilterFunc(ProgramEntity program, string searchString)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (program.ProgramId.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (program.ProgramName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (program.Purpose != null && program.Purpose.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }
}